#ifndef GENLIBCLIENTSUBSCRIPTION_H
#define GENLIBCLIENTSUBSCRIPTION_H

/*!
 * \file
 *
 * \brief Header file for GenlibClientSubscription methods.
 *
 * Do not edit this file, it is automatically generated. Please look at
 * generator.c.
 *
 * \author Marcelo Roberto Jimenez
 */
#include <stdlib.h> /* for size_t */

#include "UpnpGlobal.h" /* for UPNP_EXPORT_SPEC */

#include "UpnpString.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*!
 * GenlibClientSubscription
 */
typedef struct s_GenlibClientSubscription GenlibClientSubscription;

/*! Constructor */
UPNP_EXPORT_SPEC GenlibClientSubscription *GenlibClientSubscription_new();
/*! Destructor */
UPNP_EXPORT_SPEC void GenlibClientSubscription_delete(
	GenlibClientSubscription *p);
/*! Copy Constructor */
UPNP_EXPORT_SPEC GenlibClientSubscription *GenlibClientSubscription_dup(
	const GenlibClientSubscription *p);
/*! Assignment operator */
UPNP_EXPORT_SPEC int GenlibClientSubscription_assign(
	GenlibClientSubscription *p, const GenlibClientSubscription *q);

/*! GenlibClientSubscription_get_RenewEventId */
UPNP_EXPORT_SPEC int GenlibClientSubscription_get_RenewEventId(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_set_RenewEventId */
UPNP_EXPORT_SPEC int GenlibClientSubscription_set_RenewEventId(
	GenlibClientSubscription *p, int n);

/*! GenlibClientSubscription_get_SID */
UPNP_EXPORT_SPEC const UpnpString *GenlibClientSubscription_get_SID(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_set_SID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_set_SID(
	GenlibClientSubscription *p, const UpnpString *s);
/*! GenlibClientSubscription_get_SID_Length */
UPNP_EXPORT_SPEC size_t GenlibClientSubscription_get_SID_Length(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_get_SID_cstr */
UPNP_EXPORT_SPEC const char *GenlibClientSubscription_get_SID_cstr(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_strcpy_SID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strcpy_SID(
	GenlibClientSubscription *p, const char *s);
/*! GenlibClientSubscription_strncpy_SID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strncpy_SID(
	GenlibClientSubscription *p, const char *s, size_t n);
/*! GenlibClientSubscription_clear_SID */
UPNP_EXPORT_SPEC void GenlibClientSubscription_clear_SID(
	GenlibClientSubscription *p);

/*! GenlibClientSubscription_get_ActualSID */
UPNP_EXPORT_SPEC const UpnpString *GenlibClientSubscription_get_ActualSID(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_set_ActualSID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_set_ActualSID(
	GenlibClientSubscription *p, const UpnpString *s);
/*! GenlibClientSubscription_get_ActualSID_Length */
UPNP_EXPORT_SPEC size_t GenlibClientSubscription_get_ActualSID_Length(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_get_ActualSID_cstr */
UPNP_EXPORT_SPEC const char *GenlibClientSubscription_get_ActualSID_cstr(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_strcpy_ActualSID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strcpy_ActualSID(
	GenlibClientSubscription *p, const char *s);
/*! GenlibClientSubscription_strncpy_ActualSID */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strncpy_ActualSID(
	GenlibClientSubscription *p, const char *s, size_t n);
/*! GenlibClientSubscription_clear_ActualSID */
UPNP_EXPORT_SPEC void GenlibClientSubscription_clear_ActualSID(
	GenlibClientSubscription *p);

/*! GenlibClientSubscription_get_EventURL */
UPNP_EXPORT_SPEC const UpnpString *GenlibClientSubscription_get_EventURL(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_set_EventURL */
UPNP_EXPORT_SPEC int GenlibClientSubscription_set_EventURL(
	GenlibClientSubscription *p, const UpnpString *s);
/*! GenlibClientSubscription_get_EventURL_Length */
UPNP_EXPORT_SPEC size_t GenlibClientSubscription_get_EventURL_Length(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_get_EventURL_cstr */
UPNP_EXPORT_SPEC const char *GenlibClientSubscription_get_EventURL_cstr(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_strcpy_EventURL */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strcpy_EventURL(
	GenlibClientSubscription *p, const char *s);
/*! GenlibClientSubscription_strncpy_EventURL */
UPNP_EXPORT_SPEC int GenlibClientSubscription_strncpy_EventURL(
	GenlibClientSubscription *p, const char *s, size_t n);
/*! GenlibClientSubscription_clear_EventURL */
UPNP_EXPORT_SPEC void GenlibClientSubscription_clear_EventURL(
	GenlibClientSubscription *p);

/*! GenlibClientSubscription_get_Next */
UPNP_EXPORT_SPEC GenlibClientSubscription *GenlibClientSubscription_get_Next(
	const GenlibClientSubscription *p);
/*! GenlibClientSubscription_set_Next */
UPNP_EXPORT_SPEC int GenlibClientSubscription_set_Next(
	GenlibClientSubscription *p, GenlibClientSubscription *n);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* GENLIBCLIENTSUBSCRIPTION_H */
